#ifndef FTP_H_INC
#define FTP_H_INC

#include "disk.h"

#define HFTPCON HGLOBAL
#define FASCII  0
#define FIMAGE  1

#define DOESNT_EXIST    0
#define IS_FILE         1
#define IS_DIRECTORY    2

/* FTP data states - for "ftpDataState" variable. */
#define FTPSTATE_CLOSED     0
#define FTPSTATE_SENDLIST   1
#define FTPSTATE_SENDFILE   2
#define FTPSTATE_RECVFILE   3

/* FTP access types - return values from accessCheck(). */
#define NEED_PASSWORD       0
#define PASSWORD_NREQ       1
#define ANON_LOGIN          2
#define ANON_LOGIN_DENIED   3

/* File access request types - for iAccessType parameter to checkDirectoryAccess(). */
#define READ_ACCESS         0
#define WRITE_ACCESS        1

#define IPPORT_FTP_DATA 20

//#define PACKET_SIZE 512
#define PACKET_SIZE 32000

#define DATA_BUF_SIZE 0xffff

typedef struct FTPCONNECTION {
    HFTPCON hNext,hPrev;
    SOCKET socket;
    SOCKET datasocket;
    int mode;
    HGLOBAL hReadPath;
    HGLOBAL hWritePath;
    HGLOBAL hPath;
    HGLOBAL hUser;
    HGLOBAL hData;
    HFILE hFile;
    DWORD dwFileIdx;
    WORD wDataIdx,
         wDataLen;
    int ftpstate,
        ftpDataState;
    struct sockaddr_in sa;
    int iAnonymous;
} FTPCON;

/* in ftp.c */
int MungeNameToFullPathName(FTPCON far *pCon,char far *fname);
int InitFTPListen(void);
int CloseFTP(void);
int addFTPConnectToList(SOCKET s, struct sockaddr far *sa);
void acceptNewFTPConnection(void);
void ProcessFTPConnections(void);
void ProcessFTPCommand(FTPCON far *pCon);
int ProcessFTPDataCommand(FTPCON far *pCon);

extern SOCKET socketFTPListen;
extern HFTPCON FTPConList;

/* in misc.c */
int GetAccessPaths(FTPCON far *pCon);
int checkDirectoryAccess(FTPCON far *pCon, char far *lpPath, int iAccessType);
int encryptAndCompare(char far *lpToEncrypt, char far *lpEncryptedPassword);
int passwordCheck(char far *lpUser, char far *lpPass);
int accessCheck(char far *lpUser);
int WriteFileBlock(FTPCON far *pCon, int iEnd);
int ReadFileBlock(FTPCON far *pCon);
int ReadASCIIFileBlock(FTPCON far *pCon);
int lstrncmp(char far *str1, char far *str2, int n);
int FileType(char far *filename);
void StripLastFromPath(char far *lpPath);
int MungeNameToFullPathName(FTPCON far *pCon,char far *fname);
int CreateDirList(FTPCON far *pCon, char far *dirname, int lstype);
int firstname(char far *path, int type, char far *ret);
int nextname(int type, char far *ret);
char far *check_file_name(FTPCON far *pCon,char far *in_fname);

#endif

